#include <stdio.h>
#include <stdlib.h>
#include <string.h>

static char line[4096];
static char command[4096];

int main(int argc,char **argv)
{
  FILE *file,*pipe;
  char *prototype;
  int lines=0;
  int found_routine=0,n;

  setvbuf(stdout,NULL,_IONBF,0);
  if (argc<3) {
    fprintf(stderr,"usage: fixdoc <findheaders> <docfile> <headers>\n");
    return 1;
  }
  file=fopen(argv[2],"rt");
  if (!file) {
    perror("fixdoc");
    return 1;
  }
  strcpy(command,argv[1]);
  for (n=3;n<argc;++n) {
    strcat(command," ");
    strcat(command,argv[n]);
  }
  strcat(command," | head -1");
  fgets(line,sizeof(line),file);
  while (!feof(file)) {
    ++lines;
    if (!strncmp(line,"@header",strlen("@header"))) {
      fgets(line,sizeof(line),file);
      continue;
    }
    if (!strncmp(line,"@@",2) || !strncmp(line,"@\\",2)) {
      if (!found_routine) {
        /* just found the prototype of a routine */
        found_routine=1;
        prototype=strchr(line+2,'@');
        if (!prototype) {
          fprintf(stderr,"Line %d: prototype not found\n",lines);
        }
        else {
          prototype=strdup(prototype+1);
          strtok(prototype,"([;:) ,*");
        }
      }
    }
    else if (found_routine) {
      /* first line after the prototype of a routine */
      if (prototype) {
        pipe=popen(command,"w");
        if (pipe) {
          printf("@header ");
          fprintf(pipe,"%s\n",prototype);
          pclose(pipe);
        }
        else {
          perror("Error piping");
        }
        free(prototype);
      }
      found_routine=0;
    }
    printf("%s",line);
    fgets(line,sizeof(line),file);
  }
  fclose(file);
  return 0;
}
